Attribute VB_Name = "mdlRectAPI"
Option Explicit

Public Type RECT
    Left As Long
    Top As Long
    Right As Long
    Bottom As Long
End Type

'`œhԂ
Private Declare Function FillRect Lib "user32" (ByVal hDC As Long, ByRef lpRect As RECT, ByVal hBrush As Long) As Long

'`ŕ`悷
Private Declare Function FrameRect Lib "user32" (ByVal hDC As Long, ByRef lpRect As RECT, ByVal hBrush As Long) As Long

'`̘g`悷
Private Declare Function DrawFocusRect Lib "user32" (ByVal hDC As Long, ByRef lpRect As RECT) As Long

'`̓̐F_NOTZgĔ]
Private Declare Function InvertRect Lib "user32" (ByVal hDC As Long, ByRef lpRect As RECT) As Long

'`̕ӂ`悷
Private Declare Function DrawEdge Lib "user32" (ByVal hDC As Long, ByRef qrc As RECT, ByVal Edge As Long, ByVal grfFlags As Long) As Long

Public Const BDR_RAISEDOUTER = &H1  'ӂ̓𗲋N
Public Const BDR_SUNKENOUTER = &H2  'ӂ̓זv
Public Const BDR_RAISEDINNER = &H4  'ӂ̊O𗲋N
Public Const BDR_SUNKENINNER = &H8  'ӂ̊Oזv

Public Const BDR_OUTER = &H3        'ӂ̓𗲋Nӂ̓זv
Public Const BDR_INNER = &HC        'ӂ̊O𗲋Nӂ̊Oזv
Public Const BDR_RAISED = &H5       'ӂ̓𗲋Nӂ̊O𗲋N
Public Const BDR_SUNKEN = &HA       'ӂ̓זvӂ̊Oזv

Public Const EDGE_RAISED = (BDR_RAISEDOUTER Or BDR_RAISEDINNER)  'BDR_RAISED
Public Const EDGE_SUNKEN = (BDR_SUNKENOUTER Or BDR_SUNKENINNER)  'BDR_SUNKEN
Public Const EDGE_ETCHED = (BDR_SUNKENOUTER Or BDR_RAISEDINNER)  'ӂ̓זvӂ̊O𗲋N
Public Const EDGE_BUMP = (BDR_RAISEDOUTER Or BDR_SUNKENINNER)    'ӂ̓𗲋Nӂ̊Oזv

Public Const BF_LEFT = &H1    'ӂ`悷
Public Const BF_TOP = &H2     'ӂ`悷
Public Const BF_RIGHT = &H4   'Eӂ`悷
Public Const BF_BOTTOM = &H8  'ӂ`悷
Public Const BF_TOPLEFT = (BF_TOP Or BF_LEFT)         'Ӂӂ`悷
Public Const BF_TOPRIGHT = (BF_TOP Or BF_RIGHT)       'ӁEӂ`悷
Public Const BF_BOTTOMLEFT = (BF_BOTTOM Or BF_LEFT)   'Ӂӂ`悷
Public Const BF_BOTTOMRIGHT = (BF_BOTTOM Or BF_RIGHT) 'ӁEӂ`悷
Public Const BF_RECT = (BF_LEFT Or BF_TOP Or BF_RIGHT Or BF_BOTTOM) 'ӁӁӁEӂ`悷

Public Const BF_DIAGONAL = &H10  'Ίp`悷
Public Const BF_DIAGONAL_ENDTOPRIGHT = (BF_DIAGONAL Or BF_TOP Or BF_RIGHT)       'Eւ̑Ίp`悷
Public Const BF_DIAGONAL_ENDTOPLEFT = (BF_DIAGONAL Or BF_TOP Or BF_LEFT)         'E獶ւ̑Ίp`悷
Public Const BF_DIAGONAL_ENDBOTTOMLEFT = (BF_DIAGONAL Or BF_BOTTOM Or BF_LEFT)   'E獶ւ̑Ίp`悷
Public Const BF_DIAGONAL_ENDBOTTOMRIGHT = (BF_DIAGONAL Or BF_BOTTOM Or BF_RIGHT) 'Eւ̑Ίp`悷

Public Const BF_MIDDLE = &H800    '`̓hԂ
Public Const BF_SOFT = &H1000     '\tgȃfUC̃{^`悷
Public Const BF_ADJUST = &H2000   'w肷ƒ`kAɕ`ĂӂO
                                  'w肵ȂꍇA`ɕύXȂ
Public Const BF_FLAT = &H4000     'ȕӂ`悷
Public Const BF_MONO = &H8000     '̌ʂȂE`悷

'uV쐬
Private Declare Function CreateSolidBrush Lib "gdi32" (ByVal crColor As Long) As Long

Private Declare Function SelectObject Lib "gdi32" (ByVal hDC As Long, ByVal hObject As Long) As Long

Private Declare Function DeleteObject Lib "gdi32" (ByVal hObject As Long) As Long

'`悷
Private Declare Function DrawText Lib "user32" Alias "DrawTextA" (ByVal hDC As Long, ByVal lpStr As String, ByVal nCount As Long, lpRect As RECT, ByVal wFormat As Long) As Long

Private Const DT_CENTER = &H1        '𐅕
Private Const DT_VCENTER = &H4       '𐂒
Private Const DT_SINGLELINE = &H20   'Ps\

'-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-
' @  \F`悷
'   F(i)hDC      c `̃foCXReLXg̃nh
'         (i)DrawStr  c `敶
'         (i)udtRect  c RECT\
' ԂlFcTrue  ُcFalse
'=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
Public Function DrawTextRect(ByVal hDC As Long, ByVal DrawStr As String, ByRef udtRect As RECT) As Boolean
    DrawTextRect = CBool(DrawText(hDC, DrawStr, LenB(StrConv(DrawStr, vbFromUnicode)), udtRect, DT_CENTER Or DT_VCENTER Or DT_SINGLELINE))
End Function

'-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-
' @  \FFillRects
'   F(i)hDC      c `̃foCXReLXg̃nh
'         (i)udtRect  c RECT\
'         (i)RGBColor c ̐F
' ԂlFcTrue  ُcFalse
'=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
Public Function FillRectExec(ByVal hDC As Long, ByRef udtRect As RECT, ByVal RGBColor As Long) As Boolean

    Dim hBrush As Long
    
    'uV쐬
    hBrush = CreateSolidBrush(RGBColor)

    If hBrush Then
        'ẅ𖄂߂
        FillRectExec = CBool(FillRect(hDC, udtRect, hBrush))

        'uV폜
        Call DeleteObject(hBrush)
    End If
End Function

'-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-
' @  \FFrameRects
'   F(i)hDC      c `̃foCXReLXg̃nh
'         (i)udtRect  c RECT\
'         (i)RGBColor c ̐F
' ԂlFcTrue  ُcFalse
'=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
Public Function FrameRectExec(ByVal hDC As Long, ByRef udtRect As RECT, ByVal RGBColor As Long) As Boolean

    Dim hBrush As Long
    
    'uV쐬
    hBrush = CreateSolidBrush(RGBColor)

    If hBrush Then
        'ẅŕ`悷
        FrameRectExec = CBool(FrameRect(hDC, udtRect, hBrush))

        'uV폜
        Call DeleteObject(hBrush)
    End If
End Function


'-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-
' @  \FDrawFocusRects
'   F(i)hDC      c `̃foCXReLXg̃nh
'         (i)udtRect  c RECT\
' ԂlFcTrue  ُcFalse
'=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
Public Function DrawFocusRectExec(ByVal hDC As Long, ByRef udtRect As RECT) As Boolean
    DrawFocusRectExec = CBool(DrawFocusRect(hDC, udtRect))
End Function

'-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-
' @  \FInvertRects
'   F(i)hDC      c `̃foCXReLXg̃nh
'         (i)udtRect  c RECT\
' ԂlFcTrue  ُcFalse
'=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
Public Function InvertRectExec(ByVal hDC As Long, ByRef udtRect As RECT) As Boolean
    InvertRectExec = CBool(InvertRect(hDC, udtRect))
End Function

'-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-
' @  \FInvertRects
'   F(i)hDC     c `̃foCXReLXg̃nh
'         (i)udtRect c RECT\
'         (i)Edge    c Edge萔
'         (i)Flags   c tO萔
' ԂlFcTrue  ُcFalse
'=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
Public Function DrawEdgeExec(ByVal hDC As Long, ByRef udtRect As RECT, ByVal Edge As Long, ByVal Flags As Long) As Boolean
    DrawEdgeExec = CBool(DrawEdge(hDC, udtRect, Edge, Flags))
End Function

